package ds.mods.CCLights2;

import org.apache.logging.log4j.Level;

public class Config
{
    public static boolean DEBUGS = true;
    public static boolean Vanilla, IC2;
    public static Integer[] monitorSize;
    public static boolean gpu = false, monitor = false, monitorBig = false, light = false, advancedlight = false, ttrans = false, ram = false, tablet = false;
    
    public static boolean infinite = true;
    public static boolean infY = true;
    public static int range = -1;
    
    public static double packetRange = 4096.0D;
    
    static void loadConfig(net.minecraftforge.common.config.Configuration config)
    {
        config.load();
        
        gpu = config.get("Enable", "GPU", true).getBoolean();
        monitor = config.get("Enable", "Monitor", true).getBoolean();
        monitorBig = config.get("Enable", "Big_Monitor", true).getBoolean();
        light = config.get("Enable", "Light", true).getBoolean();
        advancedlight = config.get("Enable", "Advanced_Light", true).getBoolean();
        ttrans = config.get("Enable", "Tablet_Transceiver", true).getBoolean();
        ram = config.get("Enable", "RAM", true).getBoolean();
        tablet = config.get("Enable", "Tablet", true).getBoolean();
        
        infinite = config.get("Tablet", "Infinite_Range", false).getBoolean();
        infY = config.get("Tablet", "InfiniteY", false).getBoolean();
        range = config.get("Tablet", "Range", 10).getInt();
        
        infinite = range < 0; 
        
        DEBUGS = config.get("Misc", "DEBUG", false).getBoolean();
        packetRange = config.get("Misc", "PacketRange", 4096.0D).getDouble();
        Vanilla = config.get("Misc", "CompatVanilla", true).getBoolean();
        IC2 = config.get("Misc", "CompatIC2", false).getBoolean();
        parse(config.get("Misc", "MonitorSize", "256x144").getString());
        config.save();
    }
    
    private static void parse(String monitorSizez)
    {
        String[] mParser = monitorSizez.split("x");
        if (mParser.length == 2)
        {
            monitorSize = new Integer[] { Integer.decode(mParser[0]), Integer.decode(mParser[1]) };
            if (monitorSize[0] < 1 || monitorSize[1] < 1)
            {
                setDefaults();
                CCLights2.logger.log(Level.WARN, "Invalid monitor/externalmonitor size found, using defaults");
            }
        }
        else
        {
            setDefaults();
            CCLights2.logger.log(Level.WARN, "Invalid monitor/externalmonitor size found, using defaults");
        }
    }
    
    public static final void setDefaults()
    {
        monitorSize = new Integer[] { 256, 144 };
    }
}
